use ExtUtils::MakeMaker;

use strict;
local $^W = 1; #need to support 5.005x

open FH, ">server_config_flags.h" or die "open server_config.h : $!";
open CONST, ">constants.c" or die "open constants.c: $!";

my @flags = qw(NONE INIT DEBUG VERBOSE NO_DAEMON NO_FORK CHANGED_UID);
my $bits = 0;
for my $flag (@flags) {
    print FH <<EOF;
#define GTOP_Sf_${flag} $bits
#define GTOP_S_${flag}     (glibtop_server_config->flags & GTOP_Sf_$flag)
#define GTOP_S_${flag}_on  (glibtop_server_config->flags |= GTOP_Sf_$flag)
#define GTOP_S_${flag}_off (glibtop_server_config->flags &= ~GTOP_Sf_$flag)

EOF
    print CONST qq{   newCONSTSUB(stash, "$flag", newSViv(GTOP_Sf_${flag}));\n};
    if ($bits < 2) {
	$bits++;
    }
    else {
	$bits *= 2;
    }
}

close FH;
close CONST;

# load the helper lib if it wasn't loaded already by the top-level
# Makefile.PL
require "../config.pl" unless defined *main::get_glibtop_config{CODE};
my($inc, $libs, $defines) = get_glibtop_config();

WriteMakefile(
    NAME => "GTop::Server",
    VERSION_FROM => "Server.pm",
    INC  => $inc,
    LIBS => [split /\s+/, $libs],
    DEFINE => $defines,
    OBJECT => 'io.o main.o gnuserv.o version.o access.o Server.o',
    clean   => {
       FILES => "server_config_flags.h constants.c",
    },
);

